%define	CTVER	%{version}
%define	CDVER	1999.08.29
%define MDK_KBD_VER 20050108

%define major 0
%define fname console
%define libname %mklibname %fname %major

# /usr/lib/kbd/{conslefonts,consolemaps,keymaps} instead of
# /usr/share/{conslefonts,consolemaps,keymaps}
# FIXME: data really should really go to /usr/share/*
%define kbddir		%{_prefix}/lib/kbd
%define _datadir	%{kbddir}
%define _mandir		%{_prefix}/share/man

Summary:	Linux console tools
Name:		console-tools
Version:	0.2.3
Release:	%mkrel 62
Group:		Terminals
License:	GPL
URL:		http://lct.sourceforge.net/
Source0:	ftp://metalab.unc.edu/pub/Linux/system/keyboards/console-tools-%{CTVER}.tar.bz2
Source1:	ftp://metalab.unc.edu/pub/Linux/system/keyboards/console-data-%{CDVER}.tar.bz2
Source2:	keytable.init
Source3:	ftp://ftp.dementia.org/pub/linux/pc2sun.pl
Source4:	console-tools-ucwfonts.tar.bz2
Source5:	kbd-0.96-turkish.tar.bz2
Source6:	kbd-mdk-keymaps-%{MDK_KBD_VER}.tar.bz2
Source7:	configure_keyboard.sh
Source8:	ctools-cyr.tar.bz2
# on PPC we need to see whether mac or Linux keycodes are being used - stew
Patch0:		keytable.init.ppc.patch
Source10:	mac-keymaps.tar.bz2
# taken from ftp://ftp.kernel.org/pub/linux/utils/kbd/kbd-1.12.tar.bz2, where
# it's called "us-acentos.map"
Source11:	us-intl.kmap.gz

Requires(pre):	coreutils sed rpm-helper
Obsoletes:	kbd
Provides:	kbd
BuildRequires:	flex libtool >= 1.3.3 sgml-tools automake1.7 automake1.4 autoconf2.5
BuildRequires:	gettext-devel
Requires:	grep /bin/gawk
# for get_locale_encoding
Requires: initscripts >= 7.61.1-23mdk
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires(pre):	%{libname} = %{version}-%{release}

# docbook is unable to convert the sgml files to html
# disabling them in the makefiles -- pablo
Patch5:		console-tools-0.2.3-docbook.patch

# Allow consolechars & loadkeys to run from the root partition
Patch6:		console-tools-rootpart.patch

# fixes a stupid error -- pablo
Patch8:		console-tools-0.2.3-versioncoredump.patch

# some keyboards cannot have the euro in AltGr-e -- pablo
Patch9:		console-tools-0.2.3-noteuro.patch

Patch10:	console-data-1999.08.29-mandrake.patch
Patch11:	console-tools-0.2.3-tilde-with-twosuperior-in-french-keyboard.patch
Patch12:	console-tools-0.2.3-setkeycodes-fixargument.patch

# some modifications to cover PPC using Linux keycodes
Patch13:	console-tools-0.2.3-ppc-using-linux-keycodes.patch

# Thai kbds, keysysm and fonts -- pablo
Patch14:	http://www.links.nectec.or.th/~thep/th-console/console-data/console-data-thai_deb-1999.08.29-21.8.patch
Patch15:	http://www.links.nectec.or.th/~thep/th-console/console-tools/console-tools-thai_ksym.patch

# gcc 3.3
Patch16:	console-tools-gcc33.patch

# this patch removes testing of start_unicode, otherwise console font
# cannot be changed once in utf-8 mode -- pablo
Patch17:	console-tools-start_unicode.patch

# patch for a coredump when using compressed font files -- pablo
Patch18:	console-tools-0.2.3-compresscoredump.patch

# gcc 3.4
Patch19:	console-tools-0.2.3-gcc3.4-fix.patch

# update french mac keymap v3 with ftp://ftp.linux-france.org/pub/macintosh/kbd-mac-fr.tar.gz
Patch20:	console-data-1999.08.29-mac.patch

# taken from debian's 30_openvt-devfs.patch patch
Patch21:	console-tools-0.2.3-fix-openvt-option--w.patch

# fgconsole exit(0) missing
Patch22:	console-tools-0.2.3-fix-fgconsole_exit_status.patch

# Remove upper keycode limit in setkeycodes (#21741)
Patch23:	console-tools-0.2.3-no_setkeycodes_limit.patch

# Don't allow vt-is-UTF8 to run in a console != linux vt (#27948)
Patch24:	console-tools-0.2.3-vt-is-UTF8_only_linux_vt.patch

# Prevent hang of vt-is-UTF8 if it can't verify vt output (#27948)
Patch25:	console-tools-0.2.3-fscanf_nonblock.patch

%description
This package contains utilities to load console fonts and
keyboard maps.  It also includes a number of different fonts
and keyboard maps.

%package -n	%{libname}
Summary:	Libraries for console tools
Group:		System/Libraries
Provides:	lib%{fname} = %{version}-%{release}

%description -n	%{libname}
This package contains libraries for console tools

%package -n	%{libname}-devel
Summary:	Include and .so files for console tools
Group:		Development/Other
Requires(pre):	%{libname} = %{version}-%{release}
Obsoletes:	%{name}-devel
Provides:	%{name}-devel = %{version}-%{release}
Provides:	lib%{fname}-devel = %{version}-%{release}

%description -n	%{libname}-devel
This package contains include and .so files for console tools


%package -n	%{libname}-static-devel
Summary:	Static libraries for console tools
Group:		Development/Other
Requires(pre):		%{name}-devel = %{version}-%{release}
Obsoletes:	%{name}-static-devel
Provides:	%{name}-static-devel = %{version}-%{release}
Provides:	lib%{fname}-static-devel = %{version}-%{release}

%description -n	%{libname}-static-devel
This package contains static libraries for console tools.

%prep
%setup -n %{name}-%{CTVER} -q -a 1 -a4 -a5
cd console-data-%{CDVER}
%patch10 -p1
%patch20 -p1
cd ..

%patch5 -p1 -b ._db
%patch6 -p1 -b .rootpart
%patch8 -p1
%patch9 -p0
%patch11 -p1
%patch12 -p1

%ifarch ppc ppc64
%patch13 -p1
%endif

%patch14 -p0 -b .thai1
%patch15 -p1 -b .thai2
%patch16 -p0
%patch17 -p1
%patch18 -p1
%patch19 -p1 -b .gcc34
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1

# adapt for gettext >= 0.14.2 (avoid patch)
grep -q gt_LC_MESSAGES /usr/share/aclocal/lcmessage.m4 &&
perl -pi -e 's/^(\s+)AM_(LC_MESSAGES)/${1}gt_${2}/' acinclude.m4 console-data-%{CDVER}/acinclude.m4

%build
%serverbuild
%ifarch %ix86
DISABLE_RESIZECONS=
%else
DISABLE_RESIZECONS=--disable-resizecons
%endif
libtoolize -c -f
aclocal-1.4
automake-1.4
export FORCE_AUTOCONF_2_5=1
CFLAGS="%optflags -D_GNU_SOURCE"
%configure2_5x --enable-localdatadir=%_sysconfdir/sysconfig/console $DISABLE_RESIZECONS
%make

cd console-data-%{CDVER}
aclocal-1.7
automake-1.7
CFLAGS="%optflags -D_GNU_SOURCE"
%configure2_5x --enable-localdatadir=%_sysconfdir/sysconfig/console $DISABLE_RESIZECONS
%make
cd -

%install
rm -fr %buildroot
install -d -m 0755 %buildroot/%_prefix

make DESTDIR=%{buildroot} install
cd console-data-%{CDVER}
make DESTDIR=%{buildroot} install
cd ..

# don't give loadkeys SUID perms
chmod 755 %buildroot/%{_bindir}/loadkeys

# other keymaps
tar jxf %SOURCE6 -C %buildroot/%{kbddir}/
tar jxf %SOURCE8 -C %buildroot/%{kbddir}/
	  
install -d -m 0755 %buildroot/%_sysconfdir/rc.d/init.d
install -m 0755 %SOURCE2 %buildroot/%_sysconfdir/rc.d/init.d/keytable
%ifarch ppc ppc64
bzcat %{PATCH0}|patch -d %buildroot/%_sysconfdir/rc.d/init.d -p0
%endif

install -d -m 0755 %buildroot/%_sysconfdir/profile.d
install -m 0755 %SOURCE7 %buildroot/%_sysconfdir/profile.d/configure_keyboard.sh

install -d -m 0755 %buildroot//bin
#for i in loadkeys consolechars unicode_start; do
for i in consolechars unicode_start kbd_mode; do
  mv %buildroot/%_bindir/$i %buildroot/bin
  ln -s ../../bin/$i %buildroot/%_bindir/$i
done

%ifnarch %ix86
rm -f %buildroot/%_mandir/man8/resizecons.8
%endif

chmod +x %buildroot/%_libdir/*.so*
# libraries must be accessible before partition mounting
# if we want to be able to load console font before partition mounting
mkdir -p  %buildroot/lib
mv %buildroot/%_libdir/*.so* %buildroot/lib

cp -aR console-data-%{CDVER}/doc/* doc

install -m644 -D include/lct/*.h %buildroot/%{_includedir}/lct/

# more mac keymaps on ppc 
%ifarch ppc ppc64
tar jxf %SOURCE10 -C %buildroot/%{kbddir}/keymaps 
%endif

# remove unneeded files
rm -rf %buildroot/%{kbddir}/keymaps/{amiga,atari,sun}
%ifnarch ppc ppc64
rm -rf %buildroot/%{kbddir}/keymaps/mac
%endif

# us-international keymap
install -m 0644 %{SOURCE11} %buildroot/%{kbddir}/keymaps/i386/qwerty/

%find_lang %name

%clean
rm -fr %buildroot

%post
%_post_service keytable
if [ -f %_sysconfdir/sysconfig/keyboard ] ; then
    . %_sysconfdir/sysconfig/keyboard
    if [ -n "$KEYTABLE" ] ; then
        KT=`echo $KEYTABLE | sed -e "s/.*\///g" | sed -e "s/\..*//g"`
		# perl-base is required by basesystem ...
		perl -pi -e "s/KEYTABLE=.*$/KEYTABLE=$KT/g" %_sysconfdir/sysconfig/keyboard
    fi
fi
if [ -f %_sysconfdir/sysconfig/i18n ] ; then
   . %_sysconfdir/sysconfig/i18n
   if [ -d %_sysconfdir/sysconfig/console ] ; then
      if [ -n "$SYSFONT" ]; then
         mkdir -p %_sysconfdir/sysconfig/console/consolefonts
         cp -f %{kbddir}/consolefonts/$SYSFONT* \
			%_sysconfdir/sysconfig/console/consolefonts
      fi
      if [ -n "$UNIMAP" ]; then
         mkdir -p %_sysconfdir/sysconfig/console/consoletrans
         cp -f %{kbddir}/consoletrans/$UNIMAP* \
			%_sysconfdir/sysconfig/console/consoletrans
      fi
      if [ -n "$SYSFONTACM" ]; then 
         mkdir -p %_sysconfdir/sysconfig/console/consoletrans
         cp -f %{kbddir}/consoletrans/$SYSFONTACM* \
			%_sysconfdir/sysconfig/console/consoletrans
      fi
   fi
fi

%preun
%_preun_service keytable

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%files -f %name.lang
%defattr(-,root,root)
%doc README NEWS RELEASE
#
#
#
%config(noreplace) %_sysconfdir/profile.d/configure_keyboard.sh
#
%config(noreplace) %_sysconfdir/rc.d/init.d/keytable
#
#
%dir %{kbddir}
%{kbddir}/consolefonts
%{kbddir}/consoletrans
#
%dir %{kbddir}/keymaps
%{kbddir}/unidata
%{kbddir}/keymaps/include
# Warning: keyboards are not cpu-dependent but machine-dependent.
# How to distinguish Linux/PPC on Amiga/PPC (amiga kbd) and Linux/PPC
# on Apple/ppc (mac kbd) ?
#
# for now an ugly hack: ppc -> mac, sparc -> sun, i386/alpha -> i386
#%{kbddir}/keymaps/amiga
#%{kbddir}/keymaps/atari
#
# (fg) 20010411 Also ia64 has PC-like keyboards, added it here
#
# (sb) move to Linux keycodes PPC
#
# (OT) if all need it, why set an %ifarch
#%ifarch %ix86 alpha ia64 ppc x86_64 sparc
%{kbddir}/keymaps/i386
#%endif

# (sb) leave in the event user really wants mac keymaps
%ifarch ppc ppc64
%{kbddir}/keymaps/mac
%endif
/bin/unicode_start
/bin/consolechars
/bin/kbd_mode
%{_bindir}/charset
%{_bindir}/chvt
%{_bindir}/codepage
%{_bindir}/consolechars
%{_bindir}/deallocvt
%{_bindir}/dumpkeys
%{_bindir}/fgconsole
%{_bindir}/fix_bs_and_del
%{_bindir}/font2psf
%{_bindir}/getkeycodes
%{_bindir}/kbd_mode
%{_bindir}/loadkeys
%{_bindir}/loadunimap
%{_bindir}/mk_modmap
%{_bindir}/mapscrn
%{_bindir}/openvt
%{_bindir}/psfaddtable
%{_bindir}/psfgettable
%{_bindir}/psfstriptable
%ifarch %ix86
%{_bindir}/resizecons
%endif
%{_bindir}/saveunimap
%{_bindir}/screendump
%{_bindir}/setfont
%{_bindir}/setkeycodes
%{_bindir}/setleds
%{_bindir}/setmetamode
%{_bindir}/setvesablank
%{_bindir}/showcfont
%{_bindir}/showkey
%{_bindir}/splitfont
%{_bindir}/unicode_start
%{_bindir}/unicode_stop
%{_bindir}/vcstime
%{_bindir}/vt-is-UTF8
%{_bindir}/writevt
#
#
#
%{_mandir}/man1/*
%{_mandir}/man4/*
%{_mandir}/man5/*
%{_mandir}/man8/*

%files -n %{libname}
%defattr(-,root,root)
/lib/*.so.*


%files -n %{libname}-devel
%defattr(-,root,root)
%doc BUGS TODO doc/[cdf]* doc/keymaps doc/README* doc/*.txt
/lib/*.so
%{_libdir}/*.la
%dir %{_includedir}/lct
%{_includedir}/lct/*

%files -n %{libname}-static-devel
%defattr(-,root,root,-)
%_libdir/*.a




%changelog
* Wed Jun 20 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.2.3-62mdv2008.0
+ Revision: 41940
- Added patches to fix issues reported on ticket #27948:
  * patch vt-is-UTF8_only_linux_vt based on an almost equal debian
    patch: don't allow vt-is-UTF8 run in a terminal different from
    linux vt.
  * patch fscanf_nonblock: vt-is-UTF8 detection of console mode is
    unreliable because it uses terminal input/output + escape codes.
    Other processes can be writing/reading from the same vt and messing
    with results expected by fscanf function inside is_in_UTF8_mode,
    making it possibly block waiting for data. I implemented a
    workaround by using fcntl to make it nonblock, I tried a cleaner
    solution but didn't found another way. (and linux could offer an
    ioctl to check its vc->vc_utf variable, see linux/drivers/char/vt.c,
    to avoid to using the current vt-is-UTF8 messy detection).
- Added a better patch for ticket #21741, it's the same solution as
  made on kbd (removed expand_upper_keycode patch, added
  no_setkeycodes_limit).

* Wed May 09 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.2.3-61mdv2008.0
+ Revision: 25708
- Added patch expand_upper_keycode from Harry, fixes issue reported
  on #21741.


* Sun Jan 28 2007 Götz Waschk <waschk@mandriva.org> 0.2.3-60mdv2007.0
+ Revision: 114533
- Import console-tools

* Sun Jan 28 2007 Götz Waschk <waschk@mandriva.org> 0.2.3-60mdv2007.1
- unpack patches

* Mon Jan 16 2006 Pablo Saratxaga <pablo@mandriva.com> 0.2.3-60mdk
- don't launch "kbd_mode -u" from X11 (when $DISPLAY is defined)
  as that messes the X11 keyboard handling
- lowered launching order of "keytable" init script to "14", so it
  is launched before "dm" (X11) and unicode keyboard setting in console
  can be performed correctly
- fix delete key of jp106 keymap
- various new map files ({eo,fr,pl}-dvorak, ky, bg, bg_bds, mt, mt_us)

* Mon Jan 09 2006 Olivier Blin <oblin@mandriva.com> 0.2.3-59mdk
- use weak dependencies for $remote_fs in the init script
  (for now, we don't have the virtual system facilities provides
  that Suse ships in insserv.conf)

* Mon Jan 09 2006 Olivier Blin <oblin@mandriva.com> 0.2.3-58mdk
- mkrel
- fix typo in initscript

* Mon Jan 09 2006 Olivier Blin <oblin@mandriva.com> 0.2.3-57mdk
- convert parallel init to LSB

* Wed Jan 04 2006 Pablo Saratxaga <pablo@mandriva.com> 0.2.3-56mdk
- fix delete key of jp106 keymap
- moved kbd_mode and consolechars and the libraries they need
  to /, so they can be launched before partition mounting
  (requires 128KB on root partition, but nowadays, with / typically
  on the MB or more, that is not a problem, and makes console init
  a lot easier)
- fixed keytable init script so it uses the get_locale_encoding
  function from initscripts, and also call "kbd_mode -u" when in UTF-8

* Sun Jan 01 2006 Couriousous <couriousous@mandriva.org> 0.2.3-55mdk
- Add parallel init stuff
- Happy new year !

* Wed Oct 05 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.2.3-54mdk
- merge from ppc64-branch:
  * Fri Dec 17 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.2.3-46.1.100mdk
  - ppc64 support, fix keytable initscript

* Tue Aug 23 2005 Andreas Hasenack <andreas@mandriva.com> 0.2.3-53mdk
- added us-intl console keyboard map for people with US keyboards but
  who need better cedilla support (' + c = ç)
- fixed manpage location
- using make with DESTDIR instead of %%makeinstall

* Sat Aug 20 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.2.3-52mdk
- adapt for gettext >= 0.14.2 (gt_LC_MESSAGES)

* Sun Apr 03 2005 Nicolas Brouard <nicolas.brouard@mandrakesoft.org> 0.2.3-51mdk
- patch 22: fix fgconsole exit(0) missing

* Mon Jan 10 2005 Pixel <pixel@mandrakesoft.com> 0.2.3-50mdk
- patch21: fix openvt -w (from debian)

* Wed Sep 08 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.2.3-49mdk
- add BuildRequires: gettext-devel
- patch20: update french mac keymap

* Sun Sep 05 2004 Frederic Lepied <flepied@mandrakesoft.com> 0.2.3-48mdk
- only put files not linked with /usr/lib libraries in /bin to allow
  to boot on a separated /usr withotu error (bug #11042)

* Mon Jun 14 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.2.3-47mdk
- fix gcc-3.4 build (P19)
- force use of automake1.{4,7} and autoconf2.5
- cosmetics

